#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_ArenaTurretCFG.h"
std::auto_ptr<Fish_ArenaTurretCFG> Fish_ArenaTurretCFG::msSingleton(nullptr);

int Fish_ArenaTurretCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ArenaTurretCFGData* Fish_ArenaTurretCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_ArenaTurretCFGData>& Fish_ArenaTurretCFG::GetMapData()
{
	return mMapData;
}

void Fish_ArenaTurretCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_ArenaTurretCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ArenaTurretCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mOpenRate = element->IntAttribute("OpenRate");
		data.mArenaIntegral = element->IntAttribute("ArenaIntegral");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_ArenaTurretCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ArenaTurretCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_ArenaTurretCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_ArenaTurretCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_ArenaTurretCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "OpenRate", data.mOpenRate);
		LuaCfgHelper::readInt(L, "ArenaIntegral", data.mArenaIntegral);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_ArenaTurretCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ArenaTurretCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_ArenaTurretCFG* Fish_ArenaTurretCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ArenaTurretCFG());
	}
	return msSingleton.get();
}

void Fish_ArenaTurretCFG::Release()
{
	msSingleton.reset(nullptr);
}
